﻿using System;
using System.Collections.Generic;
using Com.Piwigo.Lib.IService;
using Com.Piwigo.Wpf.DTO;
using Com.Piwigo.Lib.DTO;
using Com.Piwigo.Wpf.DTO.Helper;
using Com.Piwigo.Wpf.Helper;
using Com.Piwigo.Wpf.Service;

namespace Com.Piwigo.Wpf.Command
{
    public sealed class PwgCmdDisconnect : AsyncCommand
    {
        public override string Text { get { return "Disconnect from server"; } }

        protected override void OnExecute(object parameter)
        {
            try {
                PwgSessionWPF sesWPF = PwgModelManager.Instance.Session;
                
                SendUiInfo("Logging out ...");

                PwgSession sess = null;
                sess = PwgServiceProvider.Instance.PwgSessionService.Logout();

                PwgSessionWPFHelper.AddPwgSessionInfoToPwgSessionWPF(sess, ref sesWPF);

                SendUiInfo("Removing Image and Category ...");
                if (PwgModelManager.Instance.ImageList != null)
                {
                    PwgModelManager.Instance.ImageList.Clear();
                }

                if ((PwgModelManager.Instance.CategoryList != null)
                    && (PwgModelManager.Instance.RootCategoryList != null))
                {
                    PwgModelManager.Instance.RootCategoryList.Childrens.Clear();
                }

                if (PwgModelManager.Instance.CategoryList != null)
                {
                    PwgModelManager.Instance.CategoryList.Clear();
                }

                SendUiInfo("Unset cache data ...");
                ImageCacheManager.Instance.UnsetCurrentServer();
            }
            catch (PwgServiceException ex)
            {
                SendUiInfo("Error " + ex.NumeroErr + " " + ex.MessageErr);
            }
        }
    }
}
