﻿using System;
using System.Collections.Generic;
using Com.Piwigo.Lib.IService;
using Com.Piwigo.Wpf.DTO;
using Com.Piwigo.Lib.DTO;
using Com.Piwigo.Wpf.DTO.Helper;
using Com.Piwigo.Wpf.Helper;
using Com.Piwigo.Wpf.Service;

namespace Com.Piwigo.Wpf.Command
{
    public sealed class PwgCmdGetImageforCategory : AsyncCommand
    {
        public override string Text { get { return "Get images for a category"; } }

        protected override void OnExecute(object parameter)
        {
            PwgCategoryWPF catParam;
            Int32 aPage = 0;
            Int32 aPerPage = 0;
            Int32 acount = 0;

            try
            {
                Uri uriServer = new Uri(PwgModelManager.Instance.Session.ServeurName);
                if (parameter is PwgCategoryWPF)
                {
                    PwgImageListWPF lstImgWPF = PwgModelManager.Instance.ImageList;
                    SendUiInfo("Removing image...");
                    PwgModelManager.Instance.ImageShown = null;
                    if (lstImgWPF != null)
                    {
                        lstImgWPF.Clear();
                    }

                    catParam = (PwgCategoryWPF)parameter;
                    SendUiInfo("Setting up cache data...");
                    ImageCacheManager.Instance.SetCurrentCategory(catParam.Id.ToString());

                    SendUiInfo("Retriving images list from server...");
                    List<PwgImage> lstImg = PwgServiceProvider.Instance.PwgCategoriesService.GetListOfImagesFormCategory(catParam.Id, false, null, null, null, null, null, null, null, null, null, null, null, null, null, true, ref aPage, ref aPerPage, ref  acount);
                    
                    PwgImageListWPFHelper.ConvertPwgImageListToPwgImageListWPF(lstImg, ref lstImgWPF);
                }
            }
            catch (PwgServiceException ex)
            {
                SendUiInfo("Error " + ex.NumeroErr + " " + ex.MessageErr);
            }
        }
    }
}
